//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "good.h"
#include "utils.h"
#include "bad.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    Application->OnException = HandleExceptions;
    PosForm(this, alLeft);
}
//---------------------------------------------------------------------------
/*This is a deliberate error to show how to safely handle potential memory
leaks*/
void __fastcall TForm1::btnMemorySafeClick(TObject *Sender)
{
TMemoryStream *mStream = NULL;
TFileStream *fStream = NULL;
try
    {
    mStream = new TMemoryStream;
    try
        {
        try
            {
            //forgot to do the fStream = new TFileStream(blah) !
            mStream->CopyFrom(fStream, 0);  //exception here!
            }
        catch(Exception &E)
            {
            throw ECustomException("btnMemorySafeClick", E.ClassName(), E.Message);
            }
        }
    __finally
        {
        if(fStream)
            delete fStream;
        }
    }
__finally
    {
    if(mStream)
        delete mStream;
    }
}
//---------------------------------------------------------------------------
/*the following simply logs messages that we've indicated are okay. We've done
this by only allowing intentional exceptions to get here. That is, if it's an
ECustomException, then we made it.

If it's not an ECustomException and it gets here then something went wrong and
we need to decide how to handle them. In this case, we still log the error but
then dump the application. */
void __fastcall TForm1::HandleExceptions(TObject *Sender, Exception *sException)

{
    LogError(sException);
    /*You would normally terminate the application if the following is true*/
    if(!dynamic_cast <ECustomException *> (sException))
        Application->ShowException(sException);
        //Application->Terminate();
    /*in this case we simply show the exception as if no handling was in place
    at all*/
}
//---------------------------------------------------------------------------

void __fastcall TForm1::actionBlockListBoxExecute(TObject *Sender)
{
this->Caption = ListBox1->Items->Strings[ListBox1->ItemIndex];
ListBox1->Items->Delete(ListBox1->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::actionBlockListBoxUpdate(TObject *Sender)
{
TAction *TempAction = dynamic_cast <TAction *> (Sender);

if(TempAction)
    {
    if (ListBox1->ItemIndex < 0)
        TempAction->Enabled = false;
    else
        TempAction->Enabled = true;
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::actionNumbersOnlyExecute(TObject *Sender)
{
this->Caption = Edit1->Text;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::actionNumbersOnlyUpdate(TObject *Sender)
{
TAction *TempAction = dynamic_cast <TAction *> (Sender);

if(TempAction)
    {
    try
        {
        StrToInt(Edit1->Text);
        TempAction->Enabled = true;
        }
    catch(...)
        {
        TempAction->Enabled = false;
        }
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnGoodFileClick(TObject *Sender)
{
TFileStream *MyFile = NULL;
String fName, s;
char *Buffy = NULL;
TSysCharSet BreakChars;

BreakChars = BreakChars << '.' << '-' << ' ';

if (Edit2->Text.IsEmpty())
    fName = GetParentFolder() + "testfile.txt";
else
    fName = Edit2->Text;

try
    {
    MyFile = new TFileStream(fName, fmOpenReadWrite);
    try
        {
        Buffy = new char[MyFile->Size + 1];
        MyFile->Read(Buffy, MyFile->Size);
        Buffy[MyFile->Size] = '\0';   //add null terminator
        this->Caption = Buffy;
        }
    __finally
        {
        if(Buffy)
            delete [] Buffy;
        }
    }
catch(...)
    {
    try
        {
        ::RaiseLastWin32Error();
        }
    catch(EWin32Error &E)
        {
        switch(::GetLastError())
            {
            case 2:     //file not found
            case 3:     //path not found
            case 15:    //invalid drive
            case 55:    //device does not exist
                s = "The file was not found in the location you gave\r\n\r\n\"";
                s = s + fName + "\"\r\n\r\n";
                s = s + "Please verify that the file exists in that location or ";
                s = s + "please choose a file that exists.";
                break;
            case 4:     //too many files already open
                s = "You currently have too many files open on the system. Please ";
                s = s + "close some open files and try to open the file again.";
                break;
            case 5:     //Access is denied
            case 19:    //write protected device?
            case 65:    //network access denied ?
                s = "Access to the file has been denied. Please ensure that you ";
                s = s + "have read and write privelidges to the file\r\n\r\n\"";
                s = s + fName + "\"\r\n\r\n";
                s = s + "by right clicking on the file and checking the properties ";
                s = s + "option.";
                break;
            case 53:    //bad network path
            case 54:    //network busy
            case 67:    //
                s = "The network path is currently unavailable. Please check your ";
                s = s + "network connections and try again.";
                break;
            default:
                s = "Something else occured!";
                break;
            }
        //size message
        s = WrapText(s, "\r\n", BreakChars, (Screen->Width / 3));
        //display and log message
        Application->MessageBox(s.c_str(),
                                "An Error Occurred trying to open the file",
                                MB_OK | MB_ICONINFORMATION);
        throw ECustomException("btnGoodFileClick", E.ClassName(), E.Message);
        }
    }
}
//---------------------------------------------------------------------------

